# coding: utf-8

"""
    Yanport API

    ## À propos Voici quelques ressources qui vous aideront à explorer notre API, si vous avez des problèmes ou des demandes, veuillez contacter le [support](mailto:support@yanport.com). ## REST API Nos services webs utilisent le protocle **HTTPS** sur le port 443, tout accès en HTTP sur le port 80 est bloqué par notre pare-feu. Les échanges de données sont réalisés en **JSON**. ## Authentification Avant de commencer à explorer notre API, vous devez nous [contacter](https://www.yanport.com/contact) afin d'obtenir un [JSON Web Token](https://jwt.io) (**JWT**) qui vous permettra de vous identifier à chaque requêtes. ### JWT (header) La méthode privilégiée pour s'authentifier est de passer à chaque requêtes le token dans le header `Authorization: Bearer {{ JWT }}` en remplaçant `{{ JWT }}` par votre token. ### JWT (query param) Il est aussi possible de passer le token directement en query param de la requête `https://api.yanport.com/?token={{ JWT }}`. (_privilégié le passage par header en production._) ## Pour démarrer Lorsque vous disposez de votre token d'authentification, vous pouvez commencer à explorer notre API grâce au boutton  `Try it out` sur chacun de nos webs services. Mais au préalable, vous devez vous authentifier en cliquant sur le boutton `Authorize `, en remplissant l'input `api_key` avec `Bearer {{ JWT }}`.  **Exemple** `Bearer eyUEkiLCJh...CHCUiBfD63oxoo=` ## Limitation Toutes les requêtes à notre API sont loggées, c'est pourquoi vous devez respecter nos [CGU](https://dev.yanport.com/cgu) afin d'éviter tout usage abusif de notre API. 

    OpenAPI spec version: 1.0
    Contact: dev@yanport.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ModelProperty(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'external_id': 'str',
        'type': 'str',
        'sub_type': 'str',
        'features': 'PropertyFeatures',
        'marketing': 'PropertyMarketing',
        'address': 'Address',
        'ads': 'list[AdRef]'
    }

    attribute_map = {
        'id': 'id',
        'external_id': 'externalId',
        'type': 'type',
        'sub_type': 'subType',
        'features': 'features',
        'marketing': 'marketing',
        'address': 'address',
        'ads': 'ads'
    }

    def __init__(self, id=None, external_id=None, type=None, sub_type=None, features=None, marketing=None, address=None, ads=None):
        """
        ModelProperty - a model defined in Swagger
        """

        self._id = None
        self._external_id = None
        self._type = None
        self._sub_type = None
        self._features = None
        self._marketing = None
        self._address = None
        self._ads = None

        if id is not None:
          self.id = id
        if external_id is not None:
          self.external_id = external_id
        if type is not None:
          self.type = type
        if sub_type is not None:
          self.sub_type = sub_type
        if features is not None:
          self.features = features
        if marketing is not None:
          self.marketing = marketing
        if address is not None:
          self.address = address
        if ads is not None:
          self.ads = ads

    @property
    def id(self):
        """
        Gets the id of this ModelProperty.

        :return: The id of this ModelProperty.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this ModelProperty.

        :param id: The id of this ModelProperty.
        :type: str
        """

        self._id = id

    @property
    def external_id(self):
        """
        Gets the external_id of this ModelProperty.

        :return: The external_id of this ModelProperty.
        :rtype: str
        """
        return self._external_id

    @external_id.setter
    def external_id(self, external_id):
        """
        Sets the external_id of this ModelProperty.

        :param external_id: The external_id of this ModelProperty.
        :type: str
        """

        self._external_id = external_id

    @property
    def type(self):
        """
        Gets the type of this ModelProperty.

        :return: The type of this ModelProperty.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this ModelProperty.

        :param type: The type of this ModelProperty.
        :type: str
        """
        allowed_values = ["HOUSE", "APARTMENT", "PREMISES", "LAND", "BUILDING", "PARKING"]
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def sub_type(self):
        """
        Gets the sub_type of this ModelProperty.

        :return: The sub_type of this ModelProperty.
        :rtype: str
        """
        return self._sub_type

    @sub_type.setter
    def sub_type(self, sub_type):
        """
        Sets the sub_type of this ModelProperty.

        :param sub_type: The sub_type of this ModelProperty.
        :type: str
        """
        allowed_values = ["CHALET", "MANSION", "CASTLE", "HOMESTEAD", "LOFT", "DUPLEX", "TRIPLEX", "SHOP", "OFFICE"]
        if sub_type not in allowed_values:
            raise ValueError(
                "Invalid value for `sub_type` ({0}), must be one of {1}"
                .format(sub_type, allowed_values)
            )

        self._sub_type = sub_type

    @property
    def features(self):
        """
        Gets the features of this ModelProperty.

        :return: The features of this ModelProperty.
        :rtype: PropertyFeatures
        """
        return self._features

    @features.setter
    def features(self, features):
        """
        Sets the features of this ModelProperty.

        :param features: The features of this ModelProperty.
        :type: PropertyFeatures
        """

        self._features = features

    @property
    def marketing(self):
        """
        Gets the marketing of this ModelProperty.

        :return: The marketing of this ModelProperty.
        :rtype: PropertyMarketing
        """
        return self._marketing

    @marketing.setter
    def marketing(self, marketing):
        """
        Sets the marketing of this ModelProperty.

        :param marketing: The marketing of this ModelProperty.
        :type: PropertyMarketing
        """

        self._marketing = marketing

    @property
    def address(self):
        """
        Gets the address of this ModelProperty.

        :return: The address of this ModelProperty.
        :rtype: Address
        """
        return self._address

    @address.setter
    def address(self, address):
        """
        Sets the address of this ModelProperty.

        :param address: The address of this ModelProperty.
        :type: Address
        """

        self._address = address

    @property
    def ads(self):
        """
        Gets the ads of this ModelProperty.

        :return: The ads of this ModelProperty.
        :rtype: list[AdRef]
        """
        return self._ads

    @ads.setter
    def ads(self, ads):
        """
        Sets the ads of this ModelProperty.

        :param ads: The ads of this ModelProperty.
        :type: list[AdRef]
        """

        self._ads = ads

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ModelProperty):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
