# coding: utf-8

"""
    Yanport API

    ## À propos Voici quelques ressources qui vous aideront à explorer notre API, si vous avez des problèmes ou des demandes, veuillez contacter le [support](mailto:support@yanport.com). ## REST API Nos services webs utilisent le protocle **HTTPS** sur le port 443, tout accès en HTTP sur le port 80 est bloqué par notre pare-feu. Les échanges de données sont réalisés en **JSON**. ## Authentification Avant de commencer à explorer notre API, vous devez nous [contacter](https://www.yanport.com/contact) afin d'obtenir un [JSON Web Token](https://jwt.io) (**JWT**) qui vous permettra de vous identifier à chaque requêtes. ### JWT (header) La méthode privilégiée pour s'authentifier est de passer à chaque requêtes le token dans le header `Authorization: Bearer {{ JWT }}` en remplaçant `{{ JWT }}` par votre token. ### JWT (query param) Il est aussi possible de passer le token directement en query param de la requête `https://api.yanport.com/?token={{ JWT }}`. (_privilégié le passage par header en production._) ## Pour démarrer Lorsque vous disposez de votre token d'authentification, vous pouvez commencer à explorer notre API grâce au boutton  `Try it out` sur chacun de nos webs services. Mais au préalable, vous devez vous authentifier en cliquant sur le boutton `Authorize `, en remplissant l'input `api_key` avec `Bearer {{ JWT }}`.  **Exemple** `Bearer eyUEkiLCJh...CHCUiBfD63oxoo=` ## Limitation Toutes les requêtes à notre API sont loggées, c'est pourquoi vous devez respecter nos [CGU](https://dev.yanport.com/cgu) afin d'éviter tout usage abusif de notre API. 

    OpenAPI spec version: 1.0
    Contact: dev@yanport.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class PropertyFeaturesConstruction(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'year': 'int',
        'urbanism_rules': 'list[str]'
    }

    attribute_map = {
        'year': 'year',
        'urbanism_rules': 'urbanismRules'
    }

    def __init__(self, year=None, urbanism_rules=None):
        """
        PropertyFeaturesConstruction - a model defined in Swagger
        """

        self._year = None
        self._urbanism_rules = None

        if year is not None:
          self.year = year
        if urbanism_rules is not None:
          self.urbanism_rules = urbanism_rules

    @property
    def year(self):
        """
        Gets the year of this PropertyFeaturesConstruction.

        :return: The year of this PropertyFeaturesConstruction.
        :rtype: int
        """
        return self._year

    @year.setter
    def year(self, year):
        """
        Sets the year of this PropertyFeaturesConstruction.

        :param year: The year of this PropertyFeaturesConstruction.
        :type: int
        """
        if year is not None and year > 2500:
            raise ValueError("Invalid value for `year`, must be a value less than or equal to `2500`")
        if year is not None and year < 1500:
            raise ValueError("Invalid value for `year`, must be a value greater than or equal to `1500`")

        self._year = year

    @property
    def urbanism_rules(self):
        """
        Gets the urbanism_rules of this PropertyFeaturesConstruction.

        :return: The urbanism_rules of this PropertyFeaturesConstruction.
        :rtype: list[str]
        """
        return self._urbanism_rules

    @urbanism_rules.setter
    def urbanism_rules(self, urbanism_rules):
        """
        Sets the urbanism_rules of this PropertyFeaturesConstruction.

        :param urbanism_rules: The urbanism_rules of this PropertyFeaturesConstruction.
        :type: list[str]
        """
        allowed_values = ["SEISMIC_ZONE", "TECHNOLOGICAL_ZONE", "FLOOD_ZONE", "CLASSIFIED_ZONE", "NOISE_ZONE", "PROTECTED_NATURAL_ZONE", "LANDSLIDE_ZONE"]
        if not set(urbanism_rules).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid values for `urbanism_rules` [{0}], must be a subset of [{1}]"
                .format(", ".join(map(str, set(urbanism_rules)-set(allowed_values))),
                        ", ".join(map(str, allowed_values)))
            )

        self._urbanism_rules = urbanism_rules

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PropertyFeaturesConstruction):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
