# coding: utf-8

"""
    Yanport API

    ## À propos Voici quelques ressources qui vous aideront à explorer notre API, si vous avez des problèmes ou des demandes, veuillez contacter le [support](mailto:support@yanport.com). ## REST API Nos services webs utilisent le protocle **HTTPS** sur le port 443, tout accès en HTTP sur le port 80 est bloqué par notre pare-feu. Les échanges de données sont réalisés en **JSON**. ## Authentification Avant de commencer à explorer notre API, vous devez nous [contacter](https://www.yanport.com/contact) afin d'obtenir un [JSON Web Token](https://jwt.io) (**JWT**) qui vous permettra de vous identifier à chaque requêtes. ### JWT (header) La méthode privilégiée pour s'authentifier est de passer à chaque requêtes le token dans le header `Authorization: Bearer {{ JWT }}` en remplaçant `{{ JWT }}` par votre token. ### JWT (query param) Il est aussi possible de passer le token directement en query param de la requête `https://api.yanport.com/?token={{ JWT }}`. (_privilégié le passage par header en production._) ## Pour démarrer Lorsque vous disposez de votre token d'authentification, vous pouvez commencer à explorer notre API grâce au boutton  `Try it out` sur chacun de nos webs services. Mais au préalable, vous devez vous authentifier en cliquant sur le boutton `Authorize `, en remplissant l'input `api_key` avec `Bearer {{ JWT }}`.  **Exemple** `Bearer eyUEkiLCJh...CHCUiBfD63oxoo=` ## Limitation Toutes les requêtes à notre API sont loggées, c'est pourquoi vous devez respecter nos [CGU](https://dev.yanport.com/cgu) afin d'éviter tout usage abusif de notre API. 

    OpenAPI spec version: 1.0
    Contact: dev@yanport.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class RentControl(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'status': 'RentControlStatus',
        'iris_quarter_name': 'str',
        'iris_quarted_id': 'str',
        'min': 'float',
        'max': 'float'
    }

    attribute_map = {
        'status': 'status',
        'iris_quarter_name': 'irisQuarterName',
        'iris_quarted_id': 'irisQuartedId',
        'min': 'min',
        'max': 'max'
    }

    def __init__(self, status=None, iris_quarter_name=None, iris_quarted_id=None, min=None, max=None):
        """
        RentControl - a model defined in Swagger
        """

        self._status = None
        self._iris_quarter_name = None
        self._iris_quarted_id = None
        self._min = None
        self._max = None

        if status is not None:
          self.status = status
        if iris_quarter_name is not None:
          self.iris_quarter_name = iris_quarter_name
        if iris_quarted_id is not None:
          self.iris_quarted_id = iris_quarted_id
        if min is not None:
          self.min = min
        if max is not None:
          self.max = max

    @property
    def status(self):
        """
        Gets the status of this RentControl.

        :return: The status of this RentControl.
        :rtype: RentControlStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this RentControl.

        :param status: The status of this RentControl.
        :type: RentControlStatus
        """

        self._status = status

    @property
    def iris_quarter_name(self):
        """
        Gets the iris_quarter_name of this RentControl.

        :return: The iris_quarter_name of this RentControl.
        :rtype: str
        """
        return self._iris_quarter_name

    @iris_quarter_name.setter
    def iris_quarter_name(self, iris_quarter_name):
        """
        Sets the iris_quarter_name of this RentControl.

        :param iris_quarter_name: The iris_quarter_name of this RentControl.
        :type: str
        """

        self._iris_quarter_name = iris_quarter_name

    @property
    def iris_quarted_id(self):
        """
        Gets the iris_quarted_id of this RentControl.

        :return: The iris_quarted_id of this RentControl.
        :rtype: str
        """
        return self._iris_quarted_id

    @iris_quarted_id.setter
    def iris_quarted_id(self, iris_quarted_id):
        """
        Sets the iris_quarted_id of this RentControl.

        :param iris_quarted_id: The iris_quarted_id of this RentControl.
        :type: str
        """

        self._iris_quarted_id = iris_quarted_id

    @property
    def min(self):
        """
        Gets the min of this RentControl.

        :return: The min of this RentControl.
        :rtype: float
        """
        return self._min

    @min.setter
    def min(self, min):
        """
        Sets the min of this RentControl.

        :param min: The min of this RentControl.
        :type: float
        """

        self._min = min

    @property
    def max(self):
        """
        Gets the max of this RentControl.

        :return: The max of this RentControl.
        :rtype: float
        """
        return self._max

    @max.setter
    def max(self, max):
        """
        Sets the max of this RentControl.

        :param max: The max of this RentControl.
        :type: float
        """

        self._max = max

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, RentControl):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
